package thyyxxk.webserver.service.hutoolcache;

import cn.hutool.cache.Cache;
import cn.hutool.cache.CacheUtil;
import cn.hutool.core.util.StrUtil;
import lombok.Data;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import thyyxxk.webserver.dao.his.hutoolcache.HutoolCacheDao;

import java.util.List;

@Service
public class NationCache implements HutoolCacheInterface<NationCache.Nation> {
    private final HutoolCacheDao dao;
    private static final int CACHE_SIZE = 32;
    Cache<String, Nation> cache = CacheUtil.newLFUCache(CACHE_SIZE);

    @Data
    public static class Nation {
        private String code;
        private String name;
        private String pyCode;
        private String wjwCode;
    }

    @Autowired
    public NationCache(HutoolCacheDao dao) {
        this.dao = dao;
    }

    @Override
    public void put(String key, Nation value) {
        if (value != null) {
            cache.put(key, value);
        }
    }

    @Override
    public Nation get(String key) {
        if (StrUtil.isBlank(key)) {
            return new Nation();
        }
        Nation nation = cache.get(key);
        if (nation == null) {
            nation = dbInfo(key);
            put(key, nation);
        }
        return nation;
    }

    @Override
    public void del(String key) {
        cache.remove(key);
    }

    @Override
    public void clear() {
        cache.clear();
    }

    public Nation dbInfo(String key) {
        return dao.selectNation(key);
    }

    @Override
    public List<CacheAll> getAll() {
        return this.getAllUtils(cache.cacheObjIterator());
    }

    @Override
    public void refreshCache(String key) {
        put(key, dbInfo(key));
    }

    @Override
    public String getLabel() {
        return "民族";
    }
}
